(MAXDESC): Get it from FD_SETSIZE if that exists.
[bpt/emacs.git] / make-dist
CommitLineData
f7dbcf3c 1#!/bin/sh
76fb0a58
JB
2
3#### make-dist: create an Emacs distribution tar file from the current
1d650ff1 4#### source tree. This basically creates a duplicate directory
76fb0a58
JB
5#### structure, and then hard links into it only those files that should
6#### be distributed. This means that if you add a file with an odd name,
7#### you should make sure that this script will include it.
f7dbcf3c
JB
8
9progname="$0"
10
76fb0a58
JB
11### Exit if a command fails.
12### set -e
f7dbcf3c 13
76fb0a58
JB
14### Print out each line we read, for debugging's sake.
15### set -v
f7dbcf3c 16
4746118a
JB
17clean_up=yes
18make_tar=yes
1260d6ba 19newer=""
f7dbcf3c
JB
20
21while [ $# -gt 0 ]; do
22 case "$1" in
76fb0a58
JB
23 ## This option tells make-dist not to delete the staging directory
24 ## after it's done making the tar file.
1260d6ba 25 "--no-clean-up" )
4746118a
JB
26 clean_up=no
27 ;;
76fb0a58
JB
28 ## This option tells make-dist not to make a tar file. Since it's
29 ## rather pointless to build the whole staging directory and then
30 ## nuke it, using this option also selects '--no-clean-up'.
4746118a
JB
31 "--no-tar" )
32 make_tar=no
33 clean_up=no
f7dbcf3c 34 ;;
76fb0a58 35 ## This option tells make-dist to make the distribution normally, then
7b9cd64c
ER
36 ## remove all files older than the given timestamp file. This is useful
37 ## for creating incremental or patch distributions.
1260d6ba 38 "--newer")
ef15f270
JB
39 newer="$2"
40 new_extension=".new"
1260d6ba
ER
41 shift
42 ;;
922ac4c5
JB
43 ## This option tells make-dist to use `compress' instead of gzip.
44 ## Normally, make-dist uses gzip whenever it is present.
45 "--compress")
46 default_gzip="compress"
47 ;;
f7dbcf3c
JB
48 * )
49 echo "${progname}: Unrecognized argument: $1" >&2
50 exit 1
51 ;;
52 esac
53 shift
54done
55
76fb0a58 56### Make sure we're running in the right place.
f7dbcf3c 57if [ ! -d src -o ! -f src/lisp.h -o ! -d lisp -o ! -f lisp/version.el ]; then
1260d6ba
ER
58 echo "${progname}: Can't find \`src/lisp.h' and \`lisp/version.el'." >&2
59 echo "${progname} must be run in the top directory of the Emacs" >&2
f7dbcf3c
JB
60 echo "distribution tree. Cd to that directory and try again." >&2
61 exit 1
62fi
63
76fb0a58 64### Find out which version of Emacs this is.
f7dbcf3c 65version=`grep 'defconst[ ]*emacs-version' lisp/version.el \
b7cceaf1 66 | sed -e 's/^.*"\([0-9][0-9]*\.[0-9][0-9]*\)\..*$/\1/'`
f7dbcf3c 67if [ ! "${version}" ]; then
1260d6ba 68 echo "${progname}: can't find current emacs version in \`./lisp/version.el'." >&2
f7dbcf3c
JB
69 exit 1
70fi
71
f753e9aa
JB
72if grep -s "GNU Emacs version ${version}" ./man/emacs.texi > /dev/null; then
73 true
74else
75 echo "You must update the version number in \`./man/emacs.texi'"
76 exit 1
77fi
78
76fb0a58 79### Make sure the subdirectory is available.
1260d6ba 80tempparent="make-dist.tmp.$$"
f7dbcf3c 81if [ -d ${tempparent} ]; then
1260d6ba
ER
82 echo "${progname}: staging directory \`${tempparent}' already exists.
83Perhaps a previous invocation of \`${progname}' failed to clean up after
84itself. Check that directories whose names are of the form
85\`make-dist.tmp.NNNNN' don't contain any important information, remove
86them, and try again." >&2
f7dbcf3c
JB
87 exit 1
88fi
89
9f7602fd
JB
90### Check for .elc files with no corresponding .el file.
91ls -1 lisp/*.el | sed 's/\.el$/.elc/' > /tmp/el
92ls -1 lisp/*.elc > /tmp/elc
254e10d8
JB
93bogosities="`comm -13 /tmp/el /tmp/elc`"
94if [ "${bogosities}" != "" ]; then
95 echo "The following .elc files have no corresponding .el files:"
96 echo "${bogosities}"
97fi
8f731fcc 98rm -f /tmp/el /tmp/elc
9f7602fd 99
1260d6ba 100echo "Creating staging directory: \`${tempparent}'"
f7dbcf3c 101mkdir ${tempparent}
ef15f270 102emacsname="emacs-${version}${new_extension}"
f7dbcf3c
JB
103tempdir="${tempparent}/${emacsname}"
104
76fb0a58
JB
105### This trap ensures that the staging directory will be cleaned up even
106### when the script is interrupted in mid-career.
00c00348
ER
107if [ "${clean_up}" = yes ]; then
108 trap "echo 'Interrupted...cleaning up the staging directory.'; rm -rf ${tempparent}; exit 1" 1 2 15
109fi
110
1260d6ba 111echo "Creating top directory: \`${tempdir}'"
f7dbcf3c
JB
112mkdir ${tempdir}
113
76fb0a58
JB
114### We copy in the top-level files before creating the subdirectories in
115### hopes that this will make the top-level files appear first in the
116### tar file; this means that people can start reading the INSTALL and
117### README while the rest of the tar file is still unpacking. Whoopee.
1260d6ba
ER
118echo "Making links to top-level files."
119ln GETTING.GNU.SOFTWARE INSTALL PROBLEMS README move-if-change ${tempdir}
3cfb369a 120ln ChangeLog Makefile.in build-install.in configure configure.in ${tempdir}
1dce54a1 121ln make-dist ${tempdir}
76fb0a58
JB
122### Copy config.sub; it's a cross-filesystem symlink.
123cp config.sub ${tempdir}
f7dbcf3c 124
f753e9aa
JB
125echo "Updating version number in README."
126(cd ${tempdir}
127 awk \
128 '$1 " " $2 " " $3 " " $4 " " $5 == "This directory tree holds version" { $6 = version; print $0 }
129 $1 " " $2 " " $3 " " $4 " " $5 != "This directory tree holds version"' \
130 version=${version} README > tmp.README
131 mv tmp.README README)
132
133
f7dbcf3c 134echo "Creating subdirectories."
e793672b
JB
135# I think we're not going to distribute anything in external-lisp, so
136# I've removed it from this list.
97c70113 137for subdir in lisp lisp/term site-lisp \
690eca32 138 src src/m src/s src/bitmaps lib-src oldXMenu \
1d650ff1 139 etc lock cpp info man shortnames vms; do
f7dbcf3c
JB
140 mkdir ${tempdir}/${subdir}
141done
142
1260d6ba 143echo "Making links to \`lisp'."
7b9cd64c 144### Don't distribute TAGS, =*.el files, site-init.el, site-load.el, or default.el.
f7dbcf3c
JB
145(cd lisp
146 ln [a-zA-Z]*.el ../${tempdir}/lisp
147 ln [a-zA-Z]*.elc ../${tempdir}/lisp
76fb0a58
JB
148 ## simula.el doesn't keep abbreviations in simula.defns any more.
149 ## ln [a-zA-Z]*.defns ../${tempdir}/lisp
f7dbcf3c
JB
150 ln ChangeLog README ../${tempdir}/lisp
151 cd ../${tempdir}/lisp
7b9cd64c 152 rm -f TAGS =*
f7dbcf3c 153 rm -f site-init site-init.el site-init.elc
ef15f270
JB
154 rm -f site-load site-load.el site-load.elc
155 rm -f default default.el default.elc)
f7dbcf3c 156
56c31c87
RS
157#echo "Making links to \`lisp/calc-2.02'."
158#### Don't distribute =*.el files, TAGS or backups.
159#(cd lisp/calc-2.02
160# ln [a-zA-Z]*.el ../../${tempdir}/lisp/calc-2.02
161# ln [a-zA-Z]*.elc ../../${tempdir}/lisp/calc-2.02
162# ln calc.info* calc.texinfo calc-refcard.* ../../${tempdir}/lisp/calc-2.02
163# ln INSTALL Makefile README README.prev ../../${tempdir}/lisp/calc-2.02
164# cd ../../${tempdir}/lisp/calc-2.02
165# rm -f *~ TAGS)
fda4e8f6 166
1260d6ba 167echo "Making links to \`lisp/term'."
7b9cd64c 168### Don't distribute =*.el files or TAGS.
f7dbcf3c
JB
169(cd lisp/term
170 ln [a-zA-Z]*.el ../../${tempdir}/lisp/term
171 ln [a-zA-Z]*.elc ../../${tempdir}/lisp/term
33d09384 172 ln README ChangeLog ../../${tempdir}/lisp/term
7b9cd64c 173 rm -f =* TAGS)
f7dbcf3c 174
e793672b 175### echo "Making links to \`external-lisp'."
7b9cd64c 176### ### Don't distribute =*.el files or TAGS.
e793672b
JB
177### (cd external-lisp
178### ln [a-zA-Z]*.el ../${tempdir}/external-lisp
179### ln [a-zA-Z]*.elc ../${tempdir}/external-lisp
7b9cd64c
ER
180### ln ChangeLog README ../${tempdir}/external-lisp
181### rm -f =* TAGS)
1260d6ba
ER
182
183echo "Making links to \`src'."
76fb0a58 184### Don't distribute =*.[ch] files, or the configured versions of
7b9cd64c 185### config.h.in, paths.h.in, or Makefile.in, or TAGS.
f7dbcf3c 186(cd src
76fb0a58 187 echo " (If we can't link gmalloc.c, that's okay.)"
f7dbcf3c 188 ln [a-zA-Z]*.c ../${tempdir}/src
76fb0a58 189 ## Might be a symlink to a file on another filesystem.
39d6eb8e 190 test -f ../${tempdir}/src/gmalloc.c || cp gmalloc.c ../${tempdir}/src
f7dbcf3c
JB
191 ln [a-zA-Z]*.h ../${tempdir}/src
192 ln [a-zA-Z]*.s ../${tempdir}/src
193 ln README Makefile.in ymakefile ChangeLog config.h.in paths.h.in \
194 ../${tempdir}/src
195 ln .gdbinit .dbxinit ../${tempdir}/src
6f95b621 196 ln *.opt vms-pp.trans ../${tempdir}/src
f7dbcf3c 197 cd ../${tempdir}/src
ef15f270
JB
198 rm -f config.h paths.h Makefile
199 if [ -z "${newer}" ]; then
200 etags *.h *.c ../lisp/*.el
7b9cd64c
ER
201 fi
202 rm -f =* TAGS)
f7dbcf3c 203
690eca32
JB
204echo "Making links to \`src/bitmaps'."
205(cd src/bitmaps
206 ln README *.xbm ../../${tempdir}/src/bitmaps)
207
1260d6ba 208echo "Making links to \`src/m'."
f7dbcf3c 209(cd src/m
1dce54a1 210 ln README [a-zA-Z0-9]*.h ../../${tempdir}/src/m)
f7dbcf3c 211
1260d6ba 212echo "Making links to \`src/s'."
f7dbcf3c 213(cd src/s
1dce54a1 214 ln README [a-zA-Z0-9]*.h ../../${tempdir}/src/s)
f7dbcf3c 215
1260d6ba 216echo "Making links to \`lib-src'."
f7dbcf3c 217(cd lib-src
fa377791 218 ln [a-zA-Z]*.[chy] [a-zA-Z]*.lex ../${tempdir}/lib-src
1260d6ba 219 ln ChangeLog Makefile.in README testfile vcdiff rcs2log ../${tempdir}/lib-src
d1b985ec 220 ln emacs.csh rcs-checkin ../${tempdir}/lib-src
1260d6ba 221 cd ../${tempdir}/lib-src
7b9cd64c
ER
222 rm -f getdate.c getdate.tab.c y.tab.c y.tab.h
223 rm -f =* TAGS)
f7dbcf3c 224
1260d6ba 225echo "Making links to \`oldXMenu'."
f7dbcf3c 226(cd oldXMenu
8bdbf9ed 227 ln *.c *.h *.in ../${tempdir}/oldXMenu
df1ec566 228 ln README Imakefile ChangeLog ../${tempdir}/oldXMenu
f395c83a 229 ln compile.com descrip.mms ../${tempdir}/oldXMenu)
f7dbcf3c 230
1260d6ba 231echo "Making links to \`etc'."
f395c83a
JB
232### Don't distribute = files, TAGS, DOC files, backups, autosaves, or
233### tex litter.
f7dbcf3c 234(cd etc
f395c83a 235 ln `ls -d * | grep -v 'RCS' | grep -v 'Old'` ../${tempdir}/etc
f7dbcf3c 236 cd ../${tempdir}/etc
f395c83a
JB
237 rm -f DOC* *~ \#*\# *.dvi *.log *,v =* core
238 rm -f TAGS)
f7dbcf3c 239
fda4e8f6
JB
240echo "Making links to \`cpp'."
241(cd cpp
242 ln cccp.c cexp.y Makefile README ../${tempdir}/cpp)
243
66afa119
RS
244echo "Making links to \`info'."
245# Don't distribute backups or autosaves.
246(cd info
247 ln [a-zA-Z]* ../${tempdir}/info
248 cd ../${tempdir}/info
249 # Avoid an error when expanding the wildcards later.
250 ln emacs dummy~ ; ln emacs \#dummy\#
251 rm -f *~ \#*\# core)
fda4e8f6
JB
252
253echo "Making links to \`man'."
254(cd man
fa377791 255 ln *.texinfo *.texi *.aux *.cps *.fns *.kys *.vrs ../${tempdir}/man
5e808bc0
JB
256 test -f README && ln README ../${tempdir}/man
257 test -f Makefile && ln Makefile ../${tempdir}/man
56c31c87
RS
258 ln ChangeLog split-man ../${tempdir}/man
259 cp texinfo.tex texindex.c ../${tempdir}/man
4f8cc93a 260 cd ../${tempdir}/man
56c31c87
RS
261 rm -f \#*\# =* *~ core emacs-index* *.Z *.z xmail
262 rm -f emacs.?? termcap.?? gdb.?? *.log *.toc *.dvi *.oaux)
f7dbcf3c 263
1260d6ba 264echo "Making links to \`shortnames'."
f7dbcf3c
JB
265(cd shortnames
266 ln *.c ../${tempdir}/shortnames
267 ln Makefile reserved special ../${tempdir}/shortnames)
268
40eef465
JB
269echo "Making links to \`vms'."
270(cd vms
271 ln [0-9a-zA-Z]* ../${tempdir}/vms
272 cd ../${tempdir}/vms
273 rm -f *~)
274
c87b230f
JB
275### It would be nice if they could all be symlinks to etc's copy, but
276### you're not supposed to have any symlinks in distribution tar files.
277echo "Making sure copying notices are all copies of \`etc/COPYING'."
1260d6ba
ER
278rm -f ${tempdir}/etc/COPYING
279cp etc/COPYING ${tempdir}/etc/COPYING
5b246836
JB
280# I think we're not going to distribute anything in external-lisp, so
281# I've removed it from this list.
282for subdir in lisp src lib-src info shortnames; do
f7dbcf3c
JB
283 if [ -f ${tempdir}/${subdir}/COPYING ]; then
284 rm ${tempdir}/${subdir}/COPYING
285 fi
96858c42 286 cp etc/COPYING ${tempdir}/${subdir}
f7dbcf3c
JB
287done
288
5b8def65
JB
289#### Make sure that there aren't any hard links between files in the
290#### distribution; people with afs can't deal with that. Okay,
291#### actually we just re-copy anything with a link count greater
292#### than two.
293echo "Breaking intra-tree links."
e94817d7
JB
294find ${tempdir} ! -type d -links +2 \
295 -exec cp {} $$ \; -exec rm -f {} \; -exec mv $$ {} \;
5b8def65 296
1260d6ba
ER
297if [ "${newer}" ]; then
298 echo "Removing files older than $newer."
76fb0a58
JB
299 ## We remove .elc files unconditionally, on the theory that anyone picking
300 ## up an incremental distribution already has a running Emacs to byte-compile
301 ## them with.
1260d6ba
ER
302 find ${tempparent} \( -name '*.elc' -o ! -newer ${newer} \) -exec rm -f {} \;
303fi
304
4746118a 305if [ "${make_tar}" = yes ]; then
922ac4c5
JB
306 if [ "${default_gzip}" = "" ]; then
307 echo "Looking for gzip."
308 temppath=`echo $PATH | sed 's/^:/.:/
309 s/::/:.:/g
310 s/:$/:./
311 s/:/ /g'`
312 default_gzip=`(
313 for dir in ${temppath}; do
314 if [ -f ${dir}/gzip ]; then echo 'gzip --best'; exit 0; fi
315 done
316 echo compress
317 )`
318 fi
f395c83a
JB
319 case "${default_gzip}" in
320 compress* ) gzip_extension=.Z ;;
321 * ) gzip_extension=.z ;;
322 esac
4746118a 323 echo "Creating tar file."
f395c83a
JB
324 (cd ${tempparent} ; tar cvf - ${emacsname} ) \
325 | ${default_gzip} \
326 > ${emacsname}.tar${gzip_extension}
4746118a 327fi
f7dbcf3c 328
4746118a 329if [ "${clean_up}" = yes ]; then
f7dbcf3c 330 echo "Cleaning up the staging directory."
f395c83a 331 rm -rf ${tempparent}
f7dbcf3c 332fi
00c00348 333
76fb0a58 334### make-dist ends here